<?php
/*
Plugin Name: Google News Sitemap
Plugin URI: http://bueltge.de/google-news-quelle-mit-wordpress-werden/836/
Description: Generate a Google News Sitemap: <code>?feed=google_news_sitemap</code>
Version: 0.1
Author: Frank B&uuml;ltge
Author URI: http://bueltge.de/
*/


function google_news_sitemap() {
	global $wpdb;
	
	// draft, future
	$sql = "
					SELECT ID, post_date
					FROM $wpdb->posts
					WHERE post_status = 'publish'
					ORDER BY post_date_gmt DESC
					LIMIT 0, 20
				";
	$items = $wpdb->get_results($sql);
	
	if ( !headers_sent() )
		header('Content-Type: text/xml; charset=' . get_option('blog_charset'), true);
	$more = 1;
?>
<?php echo '<?xml version="1.0" encoding="'.get_option('blog_charset').'"?>'; ?>


<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"
	xmlns:news="http://www.google.com/schemas/sitemap-news/0.9">
<?php
if ( empty($items) ) {
	echo '<!-- No submissions found yet. //-->';
} else {
	foreach ($items as $item) {
?>
	<url>
		<loc><?php echo stripslashes( apply_filters( 'comment_author_url', get_permalink($item->ID) ) ); ?></loc>
		<news:news>
			<news:publication_date><?php echo mysql2date('Y-m-d', $item->post_date, 'false') . 'T' . mysql2date('H:i:s+00:00', $item->post_date, 'false'); ?></news:publication_date>
			<news:keywords><?php
	$tags     = wp_get_post_tags( $item->ID, array('fields' => 'all') );
	$tagcount = count($tags);
	for ($i = 1; $i < $tagcount; $i++) {
		echo $taglist  = str_replace( "'", '', str_replace( '"', '', urldecode($tags[$i]->name) ) );
		if ( $i != $tagcount-1 )
		 echo ', ';
	}
?></news:keywords>
		</news:news>
	</url>
	<?php
		} 
	}
?>
</urlset>
<?php
}


function add_google_news_sitemap() {
	add_feed('google_news_sitemap', 'google_news_sitemap');
}
add_action('init','add_google_news_sitemap');
?>
